SystemOrganization addCategory: #'SourceCity-Importer'!

Object subclass: #AbstractSourceCityImporterStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Importer'!

!AbstractSourceCityImporterStrategy commentStamp: '<historical>' prior: 0!
I'm the object which is needed to SourceCityImporter!

!AbstractSourceCityImporterStrategy methodsFor: 'accessing' stamp: 'DouailleErwan 6/30/2012 23:49'!
buildingsSelector 
	self subclassResponsibility! !

!AbstractSourceCityImporterStrategy methodsFor: 'accessing' stamp: 'DouailleErwan 6/30/2012 23:49'!
heightNormalizer
	self subclassResponsibility! !

!AbstractSourceCityImporterStrategy methodsFor: 'accessing' stamp: 'DouailleErwan 6/30/2012 23:49'!
heightSelector
	self subclassResponsibility! !

!AbstractSourceCityImporterStrategy methodsFor: 'accessing' stamp: 'DouailleErwan 6/30/2012 23:49'!
lowColor
	self subclassResponsibility! !

!AbstractSourceCityImporterStrategy methodsFor: 'accessing' stamp: 'DouailleErwan 6/30/2012 23:49'!
maxColor
	self subclassResponsibility! !

!AbstractSourceCityImporterStrategy methodsFor: 'accessing' stamp: 'DouailleErwan 6/30/2012 23:49'!
maxLevel
	self subclassResponsibility! !

!AbstractSourceCityImporterStrategy methodsFor: 'accessing' stamp: 'DouailleErwan 6/30/2012 23:50'!
widthNormalizer
	self subclassResponsibility! !

!AbstractSourceCityImporterStrategy methodsFor: 'accessing' stamp: 'DouailleErwan 6/30/2012 23:50'!
widthSelector
	self subclassResponsibility! !

AbstractSourceCityImporterStrategy subclass: #SourceCityImporterASTCoreRpackageStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Importer'!

!SourceCityImporterASTCoreRpackageStrategy methodsFor: 'accessing' stamp: 'DouailleErwan 7/1/2012 16:21'!
buildingsSelector 
	^#classes! !

!SourceCityImporterASTCoreRpackageStrategy methodsFor: 'accessing' stamp: 'DouailleErwan 7/1/2012 14:57'!
heightNormalizer
	^#sqrt! !

!SourceCityImporterASTCoreRpackageStrategy methodsFor: 'accessing' stamp: 'DouailleErwan 7/1/2012 14:57'!
heightSelector
	^#selectors! !

!SourceCityImporterASTCoreRpackageStrategy methodsFor: 'accessing' stamp: 'DouailleErwan 7/2/2012 11:44'!
lowColor
	^Color green! !

!SourceCityImporterASTCoreRpackageStrategy methodsFor: 'accessing' stamp: 'DouailleErwan 7/2/2012 11:44'!
maxColor
	^Color red! !

!SourceCityImporterASTCoreRpackageStrategy methodsFor: 'accessing' stamp: 'DouailleErwan 7/1/2012 14:57'!
maxLevel
	^50! !

!SourceCityImporterASTCoreRpackageStrategy methodsFor: 'accessing' stamp: 'DouailleErwan 7/1/2012 14:57'!
widthNormalizer
	^#sqrt! !

!SourceCityImporterASTCoreRpackageStrategy methodsFor: 'accessing' stamp: 'DouailleErwan 7/1/2012 14:57'!
widthSelector
	^#allInstVarNames! !

AbstractSourceCityImporterStrategy subclass: #SourceCityImporterDefaultStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Importer'!

!SourceCityImporterDefaultStrategy commentStamp: '<historical>' prior: 0!
I'm the default use of AbstractSourceCityImporter!

!SourceCityImporterDefaultStrategy methodsFor: 'accessing' stamp: 'DouailleErwan 7/1/2012 00:22'!
buildingsSelector 
	#classes! !

!SourceCityImporterDefaultStrategy methodsFor: 'accessing' stamp: 'DouailleErwan 7/1/2012 14:30'!
heightNormalizer
	^#sqrt! !

!SourceCityImporterDefaultStrategy methodsFor: 'accessing' stamp: 'DouailleErwan 7/1/2012 14:30'!
heightSelector
	^#selectors! !

!SourceCityImporterDefaultStrategy methodsFor: 'accessing' stamp: 'DouailleErwan 7/1/2012 14:31'!
lowColor
	^Color green! !

!SourceCityImporterDefaultStrategy methodsFor: 'accessing' stamp: 'DouailleErwan 7/1/2012 14:31'!
maxColor
	^Color red! !

!SourceCityImporterDefaultStrategy methodsFor: 'accessing' stamp: 'DouailleErwan 7/1/2012 14:31'!
maxLevel
	^50! !

!SourceCityImporterDefaultStrategy methodsFor: 'accessing' stamp: 'DouailleErwan 7/1/2012 14:33'!
widthNormalizer
	^#sqrt! !

!SourceCityImporterDefaultStrategy methodsFor: 'accessing' stamp: 'DouailleErwan 7/1/2012 14:32'!
widthSelector
	^#allInstVarNames! !

Object subclass: #SourceCityImporter
	instanceVariableNames: 'city districts buildings id strategy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Importer'!

!SourceCityImporter commentStamp: '<historical>' prior: 0!
I'm responsible for populating a city from a model (usually a ring model)!

!SourceCityImporter class methodsFor: 'default-model' stamp: 'DouailleErwan 7/1/2012 16:03'!
defaultModel
	^ self
		title: (City model: 'SourceCity default')
		strategy: SourceCityImporterDefaultStrategy new.
		! !

!SourceCityImporter class methodsFor: 'default-model' stamp: 'DouailleErwan 7/2/2012 10:05'!
title: aCityName strategy: aSourceCityImporterStrategy import: aCollection
	^ self new 
		city: (City model: aCityName);
		strategy: aSourceCityImporterStrategy;
		import: aCollection! !

!SourceCityImporter methodsFor: 'import' stamp: 'DouailleErwan 7/2/2012 11:11'!
basicBuilding: aClassName district: aDistrict
	^ Building forModel: aClassName 
		inDistrict: aDistrict 
		id: self id
		height: (self calculHeight: aClassName)
		width: (self calculWidth: aClassName)
		color: (self calculColor: aClassName)! !

!SourceCityImporter methodsFor: 'import' stamp: 'DouailleErwan 6/22/2012 14:48'!
basicDistrict: aPackageName city: aCity
	^District forPackage: (self packageNamed: aPackageName)
		inCity: aCity 
		id: self id.
	
	! !

!SourceCityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 6/30/2012 23:53'!
buildings
	^ buildings! !

!SourceCityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 6/30/2012 23:53'!
buildings: anObject
	buildings := anObject! !

!SourceCityImporter methodsFor: 'utils' stamp: 'DouailleErwan 7/2/2012 11:47'!
calculColor: aClassName
	| height heightLevel |
	heightLevel := self strategy maxLevel.
	(self strategy heightNormalizer asString = 'none')
	ifTrue: [
		height := (aClassName perform: self strategy heightSelector) size +1
		] 
	ifFalse: [
		heightLevel := (heightLevel perform: self strategy heightNormalizer)*2.
		height := (((aClassName perform: self strategy heightSelector) size +1) perform: self strategy heightNormalizer)*2.
		].
	(height > heightLevel)
	ifTrue: [^ self strategy maxColor] 
	ifFalse: [
		(height < (heightLevel *0.3))
		ifTrue: [^ self strategy lowColor]
		ifFalse: [
			^Color r: (self strategy lowColor red + self strategy maxColor red)*(height/heightLevel)
				g: (self strategy lowColor green + self strategy maxColor green)*(height/heightLevel)
				b: (self strategy lowColor blue + self strategy maxColor blue)*(height/heightLevel)
				].
		]
	! !

!SourceCityImporter methodsFor: 'utils' stamp: 'DouailleErwan 7/2/2012 10:30'!
calculHeight: aClassName
	(self strategy heightNormalizer asString = 'none')
	ifTrue: [^(aClassName perform: self strategy heightSelector) size +1.] 
	ifFalse: [^ (((aClassName perform: self strategy heightSelector) size +1) perform: self strategy heightNormalizer)*2.].
	! !

!SourceCityImporter methodsFor: 'utils' stamp: 'DouailleErwan 7/2/2012 10:30'!
calculWidth: aClassName
	(self strategy widthNormalizer asString = 'none')
	ifTrue: [^(aClassName perform: self strategy widthSelector) size +1.] 
	ifFalse: [^ (((aClassName perform: self strategy widthSelector) size +1) perform: self strategy widthNormalizer)*2.].
	! !

!SourceCityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 6/30/2012 23:53'!
city
	^ city! !

!SourceCityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 6/30/2012 23:53'!
city: anObject
	city := anObject! !

!SourceCityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 6/30/2012 23:53'!
districts
	^ districts! !

!SourceCityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 6/30/2012 23:53'!
districts: anObject
	districts := anObject! !

!SourceCityImporter methodsFor: 'import' stamp: 'DouailleErwan 6/22/2012 14:49'!
ensureBuilding: aClassName district: aDistrict
	^ buildings
			at: aClassName 
			ifAbsent: [ 
				self idIncrement.		
				self buildings at: id put: (self basicBuilding: aClassName district: aDistrict)].
			
						! !

!SourceCityImporter methodsFor: 'import' stamp: 'DouailleErwan 6/22/2012 14:48'!
ensureDistrict: aPackageName
	^districts 
			at: aPackageName 
			ifAbsent: [ 
				self idIncrement.
				self districts at: id put: (self basicDistrict: aPackageName city: (self city))].
			
						! !

!SourceCityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 6/30/2012 23:53'!
id
	^ id! !

!SourceCityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 6/30/2012 23:53'!
id: anObject
	id := anObject! !

!SourceCityImporter methodsFor: 'utils' stamp: 'DouailleErwan 6/18/2012 11:17'!
idIncrement
	self id: self id +1.
	^ self id! !

!SourceCityImporter methodsFor: 'import' stamp: 'DouailleErwan 6/12/2012 14:19'!
import: aCollection
	aCollection do:[:each | self importPackageAsDistrict: each].
	self importClassAsBuilding.! !

!SourceCityImporter methodsFor: 'import' stamp: 'DouailleErwan 7/1/2012 16:21'!
importClassAsBuilding
	(self city districts) do: [ :each |
		(each model perform: (self strategy buildingsSelector)) do: [ :eachClass |
			eachClass isBehavior
				ifTrue: [self ensureBuilding: eachClass district: each. ]]
			displayingProgress: 'importing ', self strategy buildingsSelector asString.
		].! !

!SourceCityImporter methodsFor: 'import' stamp: 'DouailleErwan 6/12/2012 11:40'!
importClassAsBuilding: aClassName district: aDistrict
	
	self ensureBuilding: aClassName district: aDistrict.
	! !

!SourceCityImporter methodsFor: 'import' stamp: 'DouailleErwan 6/12/2012 11:40'!
importPackageAsDistrict: aPackageName
	
	self ensureDistrict: aPackageName.
	! !

!SourceCityImporter methodsFor: 'initialize-release' stamp: 'DouailleErwan 6/12/2012 13:23'!
initialize
	super initialize.
	id := 0.
	districts := Dictionary new.
	buildings := Dictionary new.! !

!SourceCityImporter methodsFor: 'utils' stamp: 'DouailleErwan 6/12/2012 11:40'!
numberOfBuilding

	^ city districts inject: 0 into: [:sum :each | sum + each buildings size.].
! !

!SourceCityImporter methodsFor: 'utils' stamp: 'DouailleErwan 6/12/2012 11:40'!
numberOfDistrict
	^city districts size! !

!SourceCityImporter methodsFor: 'utils' stamp: 'DouailleErwan 6/12/2012 15:48'!
packageNamed: aString
	^ aString! !

!SourceCityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 6/30/2012 23:53'!
strategy
	^ strategy! !

!SourceCityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 6/30/2012 23:53'!
strategy: anObject
	strategy := anObject! !

SourceCityImporter subclass: #SourceCityRPackageImporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Importer'!

SourceCityRPackageImporter class
	instanceVariableNames: 'strategy'!

!SourceCityRPackageImporter commentStamp: '<historical>' prior: 0!
I'm responsible for populating a city from a model (usually a ring model)

Specially for RPackage import!

SourceCityRPackageImporter class
	instanceVariableNames: 'strategy'!

!SourceCityRPackageImporter class methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 7/1/2012 16:06'!
defaultModel
	^ self
		city: (City model: 'SourceCity Default');
		strategy: SourceCityImporterASTCoreRpackageStrategy new.! !

!SourceCityRPackageImporter methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 6/12/2012 15:48'!
packageNamed: aString
	^ RPackageOrganizer default packageNamed: aString! !
